## tboot 0.2.0

=== DESCRIPTION ===
Package: tboot
Title: Tilted Bootstrap
Version: 0.2.0
Authors@R: c(
  person(
    family = "Morris",
    given = "Nathan",
    email = "morris_nathan@lilly.com",
    role = c("aut", "cre")),
  person(
    family = "Landau",
    given = c("William", "Michael"),
    email = "will.landau@lilly.com",
    role = c("ctb")),
  person(
    family = "Eli Lilly and Company",
    role = "cph"))
Description: Creates simulated clinical trial data with realistic correlation structures and assumed efficacy levels by using a tilted bootstrap resampling approach. Samples are drawn from observed data with some samples appearing more frequently than others. May also be used for simulating from a joint Bayesian distribution along with clinical trials based on the Bayesian distribution.
License: GPL-3
Depends: R (>= 3.4.0)
Imports: stats, quadprog, kernlab
Suggests: knitr, rmarkdown, testthat, MASS, ggplot2
VignetteBuilder: knitr
URL: https://github.com/njm18/tboot
BugReports: https://github.com/njm18/tboot/issues
RoxygenNote: 7.0.2
NeedsCompilation: no
Packaged: 2020-07-27 17:43:23 UTC; c243080
Author: Nathan Morris [aut, cre],
  William Michael Landau [ctb],
  Eli Lilly and Company [cph]
Maintainer: Nathan Morris <morris_nathan@lilly.com>
Repository: CRAN
Date/Publication: 2020-08-01 11:10:02 UTC

## tboot 0.2.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: tboot
 Title: Tilted Bootstrap
-Version: 0.2.0
+Version: 0.2.1
 Authors@R: c(
   person(
     family = "Morris",
@@ -25,10 +25,10 @@
 BugReports: https://github.com/njm18/tboot/issues
 RoxygenNote: 7.0.2
 NeedsCompilation: no
-Packaged: 2020-07-27 17:43:23 UTC; c243080
+Packaged: 2020-11-30 14:28:59 UTC; c243080
 Author: Nathan Morris [aut, cre],
   William Michael Landau [ctb],
   Eli Lilly and Company [cph]
 Maintainer: Nathan Morris <morris_nathan@lilly.com>
 Repository: CRAN
-Date/Publication: 2020-08-01 11:10:02 UTC
+Date/Publication: 2020-12-02 16:40:02 UTC

## tboot 1.6

=== tb_polgen/Makefile ===
# Copyright (c) 2006-2010, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# tb_polgen makefile
#

ROOTDIR ?= $(CURDIR)/..

include $(ROOTDIR)/Config.mk


TARGET = tb_polgen

# libraries
LIBS += -lcrypto -lz


#
# universal rules
#


build : $(TARGET)


dist : install


install : $(DISTDIR)/usr/sbin/$(TARGET)

$(DISTDIR)/usr/sbin/$(TARGET) : $(TARGET)
	[ -d $(DISTDIR)/usr/sbin ] || $(INSTALL_DIR) $(DISTDIR)/usr/sbin
	$(INSTALL_PROG) -t $(DISTDIR)/usr/sbin $(TARGET)


clean :
	rm -f *~ *.a *.so *.o *.rpm $(DEP_FILES) $(TARGET)


mrproper : clean

distclean : clean


#
# dependencies
#

$(TARGET) : tb_polgen.o commands.o policy.o param.o hash.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@


#
# implicit rules
#

HDRS := $(wildcard $(ROOTDIR)/include/*.h) $(wildcard $(CURDIR)/*.h)

BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile

%.o : %.c $(HDRS) $(BUILD_DEPS)
	$(CC) $(CFLAGS) -c $< -o $@

=== tboot/Makefile ===
# Copyright (c) 2006-2010, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# tboot makefile
#

include $(CURDIR)/Config.mk

TARGET := $(CURDIR)/tboot

# boot.o must be first
obj-y := common/boot.o
obj-y += common/acpi.o common/cmdline.o common/com.o common/e820.o
obj-y += common/elf.o common/hash.o common/index.o common/integrity.o
obj-y += common/linux.o common/loader.o common/memcmp.o common/memcpy.o
obj-y += common/misc.o common/mutex.o common/paging.o common/pci_cfgreg.o
obj-y += common/policy.o common/printk.o common/rijndael.o common/sha1.o
obj-y += common/strcmp.o common/strlen.o common/strncmp.o common/strncpy.o
obj-y += common/strtoul.o common/tb_error.o common/tboot.o common/tpm.o
obj-y += common/vga.o common/vmac.o common/vsprintf.o
obj-y += txt/acmod.o txt/errors.o txt/heap.o txt/mtrrs.o txt/txt.o
obj-y += txt/verify.o txt/vmcs.o

OBJS := $(obj-y)


TARGET_LDS := $(CURDIR)/common/tboot.lds

$(TARGET).gz : $(TARGET)
	gzip -f -9 < $< > $@

$(TARGET) : $(OBJS) $(TARGET_LDS)
	$(LD) $(LDFLAGS) -T $(TARGET_LDS) -N $(OBJS) -o $(@D)/.$(@F).0
	$(NM) -n $(@D)/.$(@F).0 >$(TARGET)-syms
	$(LD) $(LDFLAGS) -T $(TARGET_LDS) $(LDFLAGS_STRIP) $(@D)/.$(@F).0 -o $(TARGET)
	rm -f $(@D)/.$(@F).0

$(TARGET_LDS) : $(TARGET_LDS).x $(HDRS)
	$(CPP) -P -E -Ui386 $(AFLAGS) -o $@ $<

$(TARGET_LDS).x : FORCE

#
# universal rules
#
dist : install


build : $(TARGET).gz


install : $(DISTIR)/boot/$(TARGET).gz

$(DISTIR)/boot/$(TARGET).gz : $(TARGET).gz
	[ -d $(DISTDIR)/boot ] || $(INSTALL_DIR) $(DISTDIR)/boot
	$(INSTALL_DATA) $(TARGET).gz $(DISTDIR)/boot/$(notdir $(TARGET)).gz
	$(INSTALL_DATA) $(TARGET)-syms $(DISTDIR)/boot/$(notdir $(TARGET))-syms


clean :
	rm -f $(TARGET)* $(TARGET_LDS) *~ include/*~ include/txt/*~ *.o common/*~ txt/*~ common/*.o txt/*.o
	rm -f tags TAGS cscope.files cscope.in.out cscope.out cscope.po.out


distclean : clean


#
#    TAGS / tags
#
define all_sources
    ( find . -name '*.[chS]' -print )
endef
define set_exuberant_flags
    exuberant_flags=`$1 --version 2>/dev/null | grep -iq exuberant && \
	echo "-I __initdata,__exitdata,__acquires,__releases \
	    -I EXPORT_SYMBOL \
	    --extra=+f --c-kinds=+px"`
endef

.PHONY: TAGS
TAGS : 
	rm -f TAGS; \
	$(call set_exuberant_flags,etags); \
	$(all_sources) | xargs etags $$exuberant_flags -a

.PHONY: tags
tags : 
	rm -f tags; \
	$(call set_exuberant_flags,ctags); \
	$(all_sources) | xargs ctags $$exuberant_flags -a

#
#    cscope
#
.PHONY: cscope
cscope :
	$(all_sources) > cscope.files
	cscope -k -b -q

#
#    MAP
#
.PHONY: MAP
MAP :
	$(NM) -n $(TARGET)-syms | grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' > System.map

#
# implicit rules
#

HDRS := $(wildcard $(CURDIR)/include/*.h)
HDRS += $(wildcard $(CURDIR)/include/txt/*.h)

BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Config.mk $(CURDIR)/Makefile

# fix case where gcc doesn't use builtin memcmp() when built w/o optimizations
ifeq ($(debug),y)
CFLAGS += -O2
endif

%.o : %.c $(HDRS) $(BUILD_DEPS)
	$(CC) $(CFLAGS) -c $< -o $@

%.o : %.S $(HDRS) $(BUILD_DEPS)
	$(CC) $(AFLAGS) -c $< -o $@

%.i : %.c $(HDRS) $(BUILD_DEPS)
	$(CPP) $(CFLAGS) $< -o $@

# -std=gnu{89,99} gets confused by # as an end-of-line comment marker
%.s : %.S $(HDRS)  $(BUILD_DEPS)
	$(CPP) $(AFLAGS) $< -o $@

=== debian/changelog ===
tboot (1.6-0ubuntu1) oneiric; urgency=low

  * Initial release (LP: #815752)

 -- Gang Wei <gang.wei@intel.com>  Thu, 28 Jul 2011 18:27:53 +0800

=== debian/control ===
Source: tboot
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gang Wei <gang.wei@intel.com>
Build-Depends: debhelper (>= 8), libtspi-dev, libssl-dev
Standards-Version: 3.9.2
Homepage: http://sourceforge.net/projects/tboot/

Package: tboot
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Trusted Boot (tboot)
 Trusted Boot (tboot) is an open source, pre-kernel/VMM module that uses
 Intel Trusted Execution Technology (Intel TXT) to perform a measured
 and verified launch of an OS kernel/VMM.

## tboot 1.7.0

=== lcptools/Makefile ===
# Copyright (c) 2006-2010, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# lcptools makefile
#

ROOTDIR ?= $(CURDIR)/..

include $(ROOTDIR)/Config.mk


TPMNV_TARGETS := \
	tpmnv_defindex \
	tpmnv_relindex \
	tpmnv_lock     \
	tpmnv_getcap

LCP1_TARGETS := \
	lcp_writepol   \
	lcp_readpol    \
	lcp_crtpconf   \
	lcp_crtpol

LCP2_TARGETS := \
	lcp_mlehash    \
	lcp_crtpol2    \
	lcp_crtpollist \
	lcp_crtpolelt  \

tpmnv : $(TPMNV_TARGETS)

lcp1 : $(LCP1_TARGETS) lcp_mlehash

lcp2 : $(LCP2_TARGETS)


#
# universal rules
#

build : $(TPMNV_TARGETS) $(LCP1_TARGETS) $(LCP2_TARGETS)


dist : install


install :
	@set -e; for i in $(TPMNV_TARGETS) $(LCP1_TARGETS) $(LCP2_TARGETS);\
	do \
		$(MAKE) DISTDIR=$(DISTDIR) INST_TARGET=$(DISTDIR)/usr/sbin/$$i do_install; \
	done

.PHONY: do_install
do_install : $(INST_TARGET)

$(INST_TARGET) : $(notdir $(INST_TARGET))
	[ -d $(DISTDIR)/usr/sbin ] || $(INSTALL_DIR) $(DISTDIR)/usr/sbin
	$(INSTALL_PROG) -t $(DISTDIR)/usr/sbin $^


clean :
	rm -f *~ *.a *.so *.o *.rpm $(DEP_FILES) $(TPMNV_TARGETS) $(LCP1_TARGETS) $(LCP2_TARGETS) trousers_dep


mrproper : clean


distclean : clean

#
# trousers
#

trousers_dep:
	@printf "#include <trousers/tss.h>\n" | $(CC) -x c $(CFLAGS) $(LDFLAGS) $(LIBS) - -Wl,--defsym=main=0 -o $@ >/dev/null 2>&1 || (echo trousers-devel package is not installed && false)

#
# dependencies
#

LDFLAGS += -L.


# LCP v2

POLELT_PLUGINS := mle_elt.o pconf_elt.o custom_elt.o sbios_elt.o

LCP2_LIB := liblcp.a

$(LCP2_LIB) : pol.o poldata.o pollist.o polelt.o lcputils2.o hash.o
	$(AR) rc $@ $^

lcp_crtpolelt : crtpolelt.o $(POLELT_PLUGINS) $(LCP2_LIB)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -lcrypto -llcp -o $@

lcp_crtpollist : crtpollist.o $(POLELT_PLUGINS) $(LCP2_LIB)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -lcrypto -llcp -o $@

lcp_crtpol2 : crtpol2.o $(POLELT_PLUGINS) $(LCP2_LIB)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -lcrypto -llcp -o $@

lcp_mlehash : mlehash.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -lcrypto -lz -o $@


# LCP v1 and tpmnv_*

UTIL_OBJS := lcptools.o lcputils.o

LIBS += -lcrypto -ltspi -lz

$(TPMNV_TARGETS) : tpmnv_% : %.o $(UTIL_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@

$(LCP1_TARGETS) : lcp_% : %.o $(UTIL_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@


#
# implicit rules
#

HDRS := $(wildcard $(ROOTDIR)/include/*.h) $(wildcard $(CURDIR)/*.h)

BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile

%.o : %.c $(HDRS) $(BUILD_DEPS) trousers_dep
	$(CC) $(CFLAGS) -c $< -o $@

=== utils/Makefile ===
# Copyright (c) 2006-2010, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# utils makefile
#

ROOTDIR ?= $(CURDIR)/..

include $(ROOTDIR)/Config.mk

TARGETS := txt-stat acminfo parse_err

CFLAGS += -D_LARGEFILE64_SOURCE

#
# universal targets
#
build : $(TARGETS)


dist : install


install :
	@set -e; for i in $(TARGETS);\
	do \
		$(MAKE) DISTDIR=$(DISTDIR) INST_TARGET=$(DISTDIR)/usr/sbin/$$i do_install; \
	done

.PHONY: do_install
do_install : $(INST_TARGET)

$(INST_TARGET) : $(notdir $(INST_TARGET))
	[ -d $(DISTDIR)/usr/sbin ] || $(INSTALL_DIR) $(DISTDIR)/usr/sbin
	$(INSTALL_PROG) -t $(DISTDIR)/usr/sbin $^


clean :
	rm -f $(TARGETS) *~ *.o *.mod.* *.symvers


distclean : clean


#
# dependencies
#

BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile

txt-stat : txt-stat.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@

acminfo : acminfo.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@

parse_err : parse_err.o
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@

%.o : %.c $(BUILD_DEPS)
	$(CC) $(CFLAGS) -c $< -o $@

=== debian/changelog ===
tboot (1.7.0-0ubuntu1) precise; urgency=low

  [ Gang Wei ]
  * New upstream release (LP: #919040).
  * debian/patches/grub-helper.patch: Add grub-mkconfig helper
    scripts. 

  [ James Page ]
  * Refreshed/documented patches for new upstream release.
  * d/copyright: Updated with Copyright and License for grub-mkconfig
    helper scripts.
  * d/control: Bumped Standards-Version to 3.9.3.
  * d/tboot.[postinst|postrm]: Tweaked to include debhelper marker.

 -- Gang Wei <gang.wei@intel.com>  Fri, 24 Feb 2012 16:48:44 +0800

## tboot 1.7.1

=== Makefile ===
# Copyright (c) 2006-2010, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# Grand Unified Makefile for tboot
#

# define ROOTDIR
export ROOTDIR=$(CURDIR)

# import global build config
include Config.mk

# (txt-test is not included because it requires pathing to Linux src)
SUBDIRS := tboot lcptools tb_polgen utils

#
# build rules
#

#
#    manifest
#
.PHONY: manifest
manifest : build
	lcptools/lcp_mlehash tboot/tboot.gz > mle_file
	lcptools/lcp_crtpol -t 0 -m mle_file -o policy_file


#
#    install
#
install :
	@set -e; for i in $(SUBDIRS); do \
		$(MAKE) install-$$i; \
	done

install-% :
	$(MAKE) -C $* install


#
#    build
#
build :
	@set -e; for i in $(SUBDIRS); do \
		$(MAKE) build-$$i; \
	done

build-% :
	$(MAKE) -C $* build


#
#    dist
#
dist : $(patsubst %,dist-%,$(SUBDIRS))
	[ -d $(DISTDIR) ] || $(INSTALL_DIR) $(DISTDIR)
	$(INSTALL_DATA) COPYING $(DISTDIR)
	$(INSTALL_DATA) README $(DISTDIR)

dist-% :
	$(MAKE) -C $* dist


#
#    world
#
# build tboot and tools, and place them in the install directory.
# 'make install' should then copy them to the normal system directories
.PHONY: world
world :
	$(MAKE) clean
	$(MAKE) dist


#
#    clean
#
clean :
	rm -f *~ include/*~ docs/*~
	@set -e; for i in $(SUBDIRS); do \
		$(MAKE) clean-$$i; \
	done

clean-% :
	$(MAKE) -C $* clean


#
#    distclean
#
distclean :
	@set -e; for i in $(SUBDIRS); do \
		$(MAKE) distclean-$$i; \
	done

distclean-% :
	$(MAKE) -C $* distclean


#
#    mrproper
#
# Linux name for GNU distclean
mrproper : distclean


#
#    help
#
.PHONY: help
help :
	@echo 'Installation targets:'
	@echo '  install          - build and install everything'
	@echo '  install-*        - build and install the * module'
	@echo ''
	@echo 'Building targets:'
	@echo '  dist             - build and install everything into local dist directory'
	@echo '  world            - clean everything'
	@echo ''
	@echo 'Cleaning targets:'
	@echo '  clean            - clean sboot and tools'
	@echo '  distclean        - clean and local downloaded files'
	@echo ''
	@echo '  uninstall        - attempt to remove installed tools'
	@echo '                     (use with extreme care!)'

#
#    uninstall
#
# Use this target with extreme care!
.PHONY: uninstall
uninstall : D=$(DESTDIR)
uninstall :
	rm -rf $(D)/boot/tboot*

=== txt-test/Makefile ===
# Copyright (c) 2006-2007, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# txt-test makefile
#

ROOTDIR ?= $(CURDIR)/..

include $(ROOTDIR)/Config.mk

LINUX_BASE_DIR = $(ROOTDIR)/../

LINUX_BUILD_DIR = $(LINUX_BASE_DIR)/build-linux-2.6.18-xen_$(TARGET_ARCH)
LINUX_SRC_DIR = $(LINUX_BASE_DIR)/linux-2.6.18-xen.hg

# uncomment to build test kernel module
#MOD_TARGET  := txt-test.ko


#
# universal targets
#
dist : install


build : $(MOD_TARGET)


install : build


clean :
	rm -f $(MOD_TARGET) *~ *.o *.mod.* *.symvers


distclean : clean


#
# dependencies
#

BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile

$(MOD_TARGET) : $(BUILD_DEPS) txt-test.c
	$(MAKE) -C $(LINUX_BUILD_DIR) M=$(CURDIR) modules

%.o : %.c $(BUILD_DEPS)
	$(CC) $(CFLAGS) -c $< -o $@

=== debian/changelog ===
tboot (1.7.1-0ubuntu3) quantal; urgency=low

  * Cherry-pick a patch from upstream to fix build failure with new zlib.

 -- Ilya Barygin <randomaction@ubuntu.com>  Sat, 06 Oct 2012 14:47:42 +0400

tboot (1.7.1-0ubuntu2) quantal; urgency=low

  * Fix FTBFS, -Werror=format.

 -- Luke Yelavich <themuso@ubuntu.com>  Wed, 20 Jun 2012 11:31:08 +1000

tboot (1.7.1-0ubuntu1) quantal; urgency=low

  * New upstream release.

 -- Logan Rosen <logatronico@gmail.com>  Mon, 18 Jun 2012 15:32:40 -0400

## tboot 1.7.3

=== debian/changelog ===
tboot (1.7.3-0ubuntu2) saucy; urgency=low

  * Update version number in the tboot grub-mkconfig helper scripts 
    (LP: #1144231)

 -- Andreas Moog <amoog@ubuntu.com>  Thu, 08 Aug 2013 22:38:52 +0200

tboot (1.7.3-0ubuntu1) raring; urgency=low

  * Missed adding the version string update
    debian/patches/version-1-3.patch
    LP: #1100152
    Thanks to Gang Wei (gang-wei)
      https://bugs.launchpad.net/intel/+bug/1100152/comments/2

 -- Tim Gardner <tim.gardner@canonical.com>  Wed, 20 Feb 2013 07:55:45 -0700

tboot (1.7.3-0ubuntu0) raring; urgency=low

  * Upstream release 1.7.3
    Dropped all patches except fix-werror-format.patch
    LP: #1100152

 -- Tim Gardner <tim.gardner@canonical.com>  Wed, 16 Jan 2013 05:45:44 -0700

## tboot 1.7.4

=== debian/changelog ===
tboot (1.7.4-0ubuntu1) saucy; urgency=low

  * Update to 1.7.4
    Dropped patches/version-1-3.patch as it was no longer needed.
    -LP: #1228768

 -- Tim Gardner <tim.gardner@canonical.com>  Mon, 23 Sep 2013 09:29:57 -0600

## tboot 1.8.0

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 include Config.mk
 
 # (txt-test is not included because it requires pathing to Linux src)
-SUBDIRS := tboot lcptools tb_polgen utils
+SUBDIRS := tboot lcptools tb_polgen utils docs
 
 #
 # build rules

=== tb_polgen/Makefile ===
--- 
+++ 
@@ -62,4 +62,4 @@
 BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile
 
 %.o : %.c $(HDRS) $(BUILD_DEPS)
-	$(CC) $(CFLAGS) -c $< -o $@
+	$(CC) $(CFLAGS) -DNO_TBOOT_LOGLVL -c $< -o $@

=== utils/Makefile ===
--- 
+++ 
@@ -61,4 +61,4 @@
 	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@
 
 %.o : %.c $(BUILD_DEPS)
-	$(CC) $(CFLAGS) -c $< -o $@
+	$(CC) $(CFLAGS) -DNO_TBOOT_LOGLVL -c $< -o $@

=== debian/changelog ===
tboot (1.8.0-0ubuntu1) trusty; urgency=low

  * Update to 1.8.0
    -LP: #1256151

 -- Tim Gardner <tim.gardner@canonical.com>  Fri, 07 Feb 2014 07:17:34 -0700

## tboot 1.8.2~0ubuntu1

=== docs/Makefile ===
# Copyright (c) 2012, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# docs makefile
#

ROOTDIR ?= $(CURDIR)/..

include $(ROOTDIR)/Config.mk

MANPATH ?= $(DISTDIR)/usr/share/man


#
# universal rules
#


build : 


dist : install


install :
	[ -d $(MANPATH)/man8 ] || $(INSTALL_DIR) $(MANPATH)/man8
	$(INSTALL_DATA) -t $(MANPATH)/man8 man/*.8*


clean :

mrproper : clean

distclean : clean


#
# dependencies
#


#
# implicit rules
#

=== lcptools/Makefile ===
--- 
+++ 
@@ -128,4 +128,4 @@
 BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile
 
 %.o : %.c $(HDRS) $(BUILD_DEPS) trousers_dep
-	$(CC) $(CFLAGS) -c $< -o $@
+	$(CC) $(CFLAGS) -DNO_TBOOT_LOGLVL -c $< -o $@

=== tboot/Makefile ===
--- 
+++ 
@@ -23,6 +23,8 @@
 obj-y += common/vga.o common/vmac.o common/vsprintf.o
 obj-y += txt/acmod.o txt/errors.o txt/heap.o txt/mtrrs.o txt/txt.o
 obj-y += txt/verify.o txt/vmcs.o
+obj-y += common/tpm_12.o common/tpm_20.o 
+obj-y += common/sha256.o
 
 OBJS := $(obj-y)
 
@@ -52,12 +54,14 @@
 build : $(TARGET).gz
 
 
-install : $(DISTIR)/boot/$(TARGET).gz
+install : $(DISTDIR)/boot/$(TARGET).gz
 
-$(DISTIR)/boot/$(TARGET).gz : $(TARGET).gz
+$(DISTDIR)/boot/$(TARGET).gz : $(TARGET).gz
 	[ -d $(DISTDIR)/boot ] || $(INSTALL_DIR) $(DISTDIR)/boot
 	$(INSTALL_DATA) $(TARGET).gz $(DISTDIR)/boot/$(notdir $(TARGET)).gz
 	$(INSTALL_DATA) $(TARGET)-syms $(DISTDIR)/boot/$(notdir $(TARGET))-syms
+	[ -d $(DISTDIR)/etc/grub.d ] || $(INSTALL_DIR) $(DISTDIR)/etc/grub.d
+	$(INSTALL) -m755 -t $(DISTDIR)/etc/grub.d 20*
 
 
 clean :

=== debian/changelog ===
tboot (1.8.2~0ubuntu1) trusty; urgency=medium

  * Security Fix: TBOOT Argument Measurement Vulnerability for GRUB2 + ELF Kernels
    CVE-2014-5118 - seclists.org/oss-sec/2014/q3/260
    sourceforge.net/p/tboot/code/ci/0efdaf7c5348701484d24562e6e5323d85bb94d3/
  * fix werror in 32 bit build environment
    dropped debian/patches/fix-werror-format.patch, merged upstream
    -LP: #1350140
  * Added debian/patches/hg_archival.patch to satisfy packaging against
    upstream orig tarball using Debian Quilt 3.0

 -- Tim Gardner <tim.gardner@canonical.com>  Wed, 30 Jul 2014 07:47:02 -0600

tboot (1.8.1-0ubuntu2) trusty; urgency=medium

  * Restore fix-werror-format.patch for i386 
  * Drop debian/patches/fix_grub-mkconfig_version.patch, merged upstream

 -- Tim Gardner <tim.gardner@canonical.com>  Tue, 10 Jun 2014 10:59:07 -0600

tboot (1.8.1-0ubuntu1) trusty; urgency=medium

  * Update to 1.8.1
    -LP: #1327981

 -- Tim Gardner <tim.gardner@canonical.com>  Tue, 10 Jun 2014 07:09:03 -0600

=== debian/watch ===
version=2
http://sf.net/tboot/tboot-(.+)\.tar\.gz

## tboot 1.8.2

=== debian/changelog ===
tboot (1.8.2-0ubuntu1) utopic; urgency=medium

  * Security Fix: TBOOT Argument Measurement Vulnerability for GRUB2 + ELF Kernels
  * fix werror in 32 bit build environment
    -LP: #1350140

 -- Tim Gardner <tim.gardner@canonical.com>  Wed, 30 Jul 2014 07:47:02 -0600

tboot (1.8.1-0ubuntu2) utopic; urgency=medium

  * Restore fix-werror-format.patch for i386 

 -- Tim Gardner <tim.gardner@canonical.com>  Tue, 10 Jun 2014 10:59:07 -0600

tboot (1.8.1-0ubuntu1) utopic; urgency=medium

  * Update to 1.8.1
    -LP: #1327981

 -- Tim Gardner <tim.gardner@canonical.com>  Tue, 10 Jun 2014 07:09:03 -0600

## tboot 1.8.3

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 include Config.mk
 
 # (txt-test is not included because it requires pathing to Linux src)
-SUBDIRS := tboot lcptools tb_polgen utils docs
+SUBDIRS := tboot lcptools lcptools-v2 tb_polgen utils docs
 
 #
 # build rules

=== tboot/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 obj-y += common/policy.o common/printk.o common/rijndael.o common/sha1.o
 obj-y += common/strcmp.o common/strlen.o common/strncmp.o common/strncpy.o
 obj-y += common/strtoul.o common/tb_error.o common/tboot.o common/tpm.o
-obj-y += common/vga.o common/vmac.o common/vsprintf.o
+obj-y += common/vga.o common/vmac.o common/vsprintf.o common/lz.o
 obj-y += txt/acmod.o txt/errors.o txt/heap.o txt/mtrrs.o txt/txt.o
 obj-y += txt/verify.o txt/vmcs.o
 obj-y += common/tpm_12.o common/tpm_20.o

=== debian/changelog ===
tboot (1.8.3-0ubuntu1) wily; urgency=medium

  * Update to 1.8.3
    http://sourceforge.net/projects/tboot/
    -LP: #1460918

 -- Tim Gardner <tim.gardner@canonical.com>  Mon, 03 Aug 2015 08:53:38 -0600

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Gang Wei <gang.wei@intel.com>
-Build-Depends: debhelper (>= 8), libtspi-dev, libssl-dev
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 8.0.0), libtspi-dev, libssl-dev
+Standards-Version: 3.9.3
 Homepage: http://sourceforge.net/projects/tboot/
 
 Package: tboot

## tboot 1.9.4

=== debian/changelog ===
tboot (1.9.4-0ubuntu1) yakkety; urgency=medium

  * Update to 1.9.4
    - LP: #1591805    

 -- Robert Hooker <sarvatt@ubuntu.com>  Thu, 08 Sep 2016 15:02:14 -0400

## tboot 1.9.5

=== debian/changelog ===
tboot (1.9.5-0ubuntu1) zesty; urgency=medium

  * Update to 1.9.5 (LP:#1645532)
    - Adds support for 4.8 and newer kernels
    - Fixes TPM2 support added in 1.9.4

 -- Robert Hooker <sarvatt@ubuntu.com>  Thu, 16 Feb 2017 09:50:36 -0500

## tboot 1.9.6

=== Makefile ===
--- 
+++ 
@@ -122,7 +122,7 @@
 	@echo '  world            - clean everything'
 	@echo ''
 	@echo 'Cleaning targets:'
-	@echo '  clean            - clean sboot and tools'
+	@echo '  clean            - clean tboot and tools'
 	@echo '  distclean        - clean and local downloaded files'
 	@echo ''
 	@echo '  uninstall        - attempt to remove installed tools'

=== tboot/Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
 TARGET_LDS := $(CURDIR)/common/tboot.lds
 
 $(TARGET).gz : $(TARGET)
-	gzip -f -9 < $< > $@
+	gzip -n -f -9 < $< > $@
 
 $(TARGET) : $(OBJS) $(TARGET_LDS)
 	$(LD) $(LDFLAGS) -T $(TARGET_LDS) -N $(OBJS) -o $(@D)/.$(@F).0

=== debian/changelog ===
tboot (1.9.6-0ubuntu1) artful; urgency=medium

  * Update to 1.9.6 (LP:#1696029)
    - GCC7 fix, adds generic FALLTHROUGH notations to avoid warnings appearing on GCC7
    - Ensure Tboot never overwrites modules in the process of moving them.
    - Add support to x2APIC, which uses 32 bit APIC ID.
    - Fix S3 secrets sealing/unsealing failures
    - Support OpenSSL 1.1.0+ for ECDSA signature verification.
    - Support OpenSSL 1.1.0+ for RSA key manipulation.
    - Adds additional checks to prevent the kernel image from being overwritten.
    - Added TCG TPM event log support.
    - Pass through the EFI memory map that's provided by grub2.
    - Fix a null pointer dereference bug when Intel TXT is disabled in BIOS.
    - Adjust KERNEL_CMDLINE_OFFSET from 0x9000 to 0x8D00.
    - Bounds checking on the kernel_cmdline string.
  * Update Standards-Version to 4.0.0
  * Update debhelper to >= 9.0.0
  * Update debian/compat to 9

 -- Colin King <colin.king@canonical.com>  Wed, 13 Sep 2017 09:23:11 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Gang Wei <gang.wei@intel.com>
-Build-Depends: debhelper (>= 8.0.0), libtspi-dev, libssl-dev
-Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9.0.0), libtspi-dev, libssl-dev
+Standards-Version: 4.0.0
 Homepage: http://sourceforge.net/projects/tboot/
 
 Package: tboot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@ 

override_dh_install:
	dh_install
	chmod 755 debian/tboot/etc/grub.d/20_*_tboot

## tboot 1.9.7

=== utils/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 include $(ROOTDIR)/Config.mk
 
-TARGETS := txt-stat acminfo parse_err
+TARGETS := txt-stat parse_err acminfo
 
 CFLAGS += -D_LARGEFILE64_SOURCE
 
@@ -54,11 +54,10 @@
 txt-stat : txt-stat.o
 	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@
 
-acminfo : acminfo.o
-	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@
-
 parse_err : parse_err.o
 	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@
 
+acminfo : acminfo.o
+	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@
 %.o : %.c $(BUILD_DEPS)
 	$(CC) $(CFLAGS) -DNO_TBOOT_LOGLVL -c $< -o $@

=== debian/changelog ===
tboot (1.9.7-0ubuntu2) focal; urgency=medium

  * d/p/gcc9-ftbfs.patch: Apply upstream patch to fix FTBFS with GCC 9.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 20 Apr 2020 22:15:09 -0400

tboot (1.9.7-0ubuntu1) cosmic; urgency=medium

  * New upstream release LP: #1731097
  * Fixes FTBFS
  * Add zlib1g-dev build-dep

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 04 Sep 2018 17:37:24 +0100

tboot (1.9.6-0ubuntu2) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 06 Feb 2018 17:55:37 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Gang Wei <gang.wei@intel.com>
-Build-Depends: debhelper (>= 9.0.0), libtspi-dev, libssl-dev
+Build-Depends: debhelper (>= 9.0.0), libtspi-dev, libssl-dev, zlib1g-dev
 Standards-Version: 4.0.0
 Homepage: http://sourceforge.net/projects/tboot/

## tboot 1.9.12+hg20200718

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 include Config.mk
 
 # (txt-test is not included because it requires pathing to Linux src)
-SUBDIRS := tboot lcptools lcptools-v2 tb_polgen utils docs
+SUBDIRS := tboot safestringlib lcptools lcptools-v2 tb_polgen utils docs
 
 #
 # build rules

=== docs/Makefile ===
--- 
+++ 
@@ -10,8 +10,7 @@
 ROOTDIR ?= $(CURDIR)/..
 
 include $(ROOTDIR)/Config.mk
-
-MANPATH ?= $(DISTDIR)/usr/share/man
+TBOOT_MANPATH ?= $(DISTDIR)/usr/share/man
 
 
 #
@@ -26,8 +25,12 @@
 
 
 install :
-	[ -d $(MANPATH)/man8 ] || $(INSTALL_DIR) $(MANPATH)/man8
-	$(INSTALL_DATA) -t $(MANPATH)/man8 man/*.8*
+	[ -d $(TBOOT_MANPATH)/man8 ] || $(INSTALL_DIR) $(TBOOT_MANPATH)/man8
+	$(INSTALL_DATA) -t $(TBOOT_MANPATH)/man8 \
+	man/txt-acminfo.8 man/lcp_readpol.8 man/lcp_writepol.8 man/tb_polgen.8 \
+	man/txt-stat.8 man/lcp2_crtpol.8 man/lcp2_crtpolelt.8 man/lcp2_crtpollist.8 \
+	man/lcp2_mlehash.8 man/txt-parse_err.8 man/tpmnv_defindex.8 man/tpmnv_getcap.8 \
+	man/tpmnv_lock.8 man/tpmnv_relindex.8
 
 
 clean :

=== lcptools-v2/Makefile ===
# Copyright (c) 2006-2010, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# lcptools makefile
#

ROOTDIR ?= $(CURDIR)/..

include $(ROOTDIR)/Config.mk


LCP2_TARGETS := \
	lcp2_mlehash    \
	lcp2_crtpol    \
	lcp2_crtpollist \
	lcp2_crtpolelt  \

lcp2 : $(LCP2_TARGETS)


#
# universal rules
#

build : $(LCP2_TARGETS)


dist : install


install :
	@set -e; for i in  $(LCP2_TARGETS);\
	do \
		$(MAKE) DISTDIR=$(DISTDIR) INST_TARGET=$(DISTDIR)/usr/sbin/$$i do_install; \
	done

.PHONY: do_install
do_install : $(INST_TARGET)

$(INST_TARGET) : $(notdir $(INST_TARGET))
	[ -d $(DISTDIR)/usr/sbin ] || $(INSTALL_DIR) $(DISTDIR)/usr/sbin
	$(INSTALL_PROG) -t $(DISTDIR)/usr/sbin $^


clean :
	rm -f *~ *.a *.so *.o *.rpm $(DEP_FILES) $(LCP2_TARGETS)

mrproper : clean


distclean : clean

#
# dependencies
#

LDFLAGS += -L.


# LCP v2

POLELT_PLUGINS := custom_elt.o mle_elt_legacy.o pconf_legacy.o sbios_elt.o stm_elt.o pconf2_elt.o mle_elt.o

LCP2_LIB := liblcp.a

LIBS += -lcrypto -llcp -lz $(ROOTDIR)/safestringlib/libsafestring.a

$(LCP2_LIB) : pol.o poldata.o pollist2.o pollist2_1.o polelt.o lcputils.o hash.o pollist1.o
	$(AR) rc $@ $^

lcp2_crtpolelt : crtpolelt.o $(POLELT_PLUGINS) $(LCP2_LIB)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@

lcp2_crtpollist : crtpollist.o $(POLELT_PLUGINS) $(LCP2_LIB)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@

lcp2_crtpol : crtpol.o $(POLELT_PLUGINS) $(LCP2_LIB)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@

lcp2_mlehash : mlehash.o $(LCP2_LIB)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@


#
# implicit rules
#

HDRS := $(wildcard $(ROOTDIR)/include/*.h) $(wildcard $(CURDIR)/*.h)

BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile

%.o : %.c $(HDRS) $(BUILD_DEPS)
	$(CC) $(CFLAGS) -DNO_TBOOT_LOGLVL -c $< -o $@

=== lcptools/Makefile ===
# Copyright (c) 2006-2010, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# lcptools makefile
#

ROOTDIR ?= $(CURDIR)/..

include $(ROOTDIR)/Config.mk


TPMNV_TARGETS := \
	tpmnv_defindex \
	tpmnv_relindex \
	tpmnv_lock     \
	tpmnv_getcap   

LCP_TARGETS := \
	lcp_writepol   \
	lcp_readpol    

tpmnv : $(TPMNV_TARGETS) $(LCP_TARGETS)


#
# universal rules
#

build : tpmnv


dist : install


install :
	@set -e; for i in $(TPMNV_TARGETS) $(LCP_TARGETS);\
	do \
		$(MAKE) DISTDIR=$(DISTDIR) INST_TARGET=$(DISTDIR)/usr/sbin/$$i do_install; \
	done

.PHONY: do_install
do_install : $(INST_TARGET)

$(INST_TARGET) : $(notdir $(INST_TARGET))
	[ -d $(DISTDIR)/usr/sbin ] || $(INSTALL_DIR) $(DISTDIR)/usr/sbin
	$(INSTALL_PROG) -t $(DISTDIR)/usr/sbin $^


clean :
	rm -f *~ *.a *.so *.o *.rpm $(DEP_FILES) $(TPMNV_TARGETS) $(LCP_TARGETS) trousers_dep


mrproper : clean


distclean : clean

#
# trousers
#

trousers_dep:
	@printf "#include <trousers/tss.h>\n" | $(CC) -x c $(CFLAGS) $(LDFLAGS) $(LIBS) - -Wl,--defsym=main=0 -o $@ >/dev/null 2>&1 || (echo trousers-devel package is not installed && false)

#
# dependencies
#

LDFLAGS += -L.


# LCP v1 and tpmnv_*

UTIL_OBJS := lcptools.o lcputils.o

LIBS += -lcrypto -ltspi -lz

$(TPMNV_TARGETS) : tpmnv_% : %.o $(UTIL_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) $(ROOTDIR)/safestringlib/libsafestring.a -o $@

$(LCP_TARGETS) : lcp_% : %.o $(UTIL_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) $(ROOTDIR)/safestringlib/libsafestring.a -o $@


#
# implicit rules
#

HDRS := $(wildcard $(ROOTDIR)/include/*.h) $(wildcard $(CURDIR)/*.h)

BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile

%.o : %.c $(HDRS) $(BUILD_DEPS) trousers_dep
	$(CC) $(CFLAGS) -DNO_TBOOT_LOGLVL -c $< -o $@

=== tb_polgen/Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 TARGET = tb_polgen
 
 # libraries
-LIBS += -lcrypto -lz
+LIBS += -lcrypto -lz $(ROOTDIR)/safestringlib/libsafestring.a
 
 
 #

=== tboot/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 # boot.o must be first
 obj-y := common/boot.o
-obj-y += common/acpi.o common/cmdline.o common/com.o common/e820.o
+obj-y += common/acpi.o common/cmdline.o common/com.o common/e820.o common/vtd.o
 obj-y += common/elf.o common/hash.o common/index.o common/integrity.o
 obj-y += common/linux.o common/loader.o common/memcmp.o common/memcpy.o
 obj-y += common/misc.o common/mutex.o common/paging.o common/pci_cfgreg.o
@@ -24,24 +24,25 @@
 obj-y += txt/acmod.o txt/errors.o txt/heap.o txt/mtrrs.o txt/txt.o
 obj-y += txt/verify.o txt/vmcs.o
 obj-y += common/tpm_12.o common/tpm_20.o 
-obj-y += common/sha256.o
+obj-y += common/sha256.o common/sha512.o common/sha384.o common/efi_memmap.o
 
 OBJS := $(obj-y)
 
 
 TARGET_LDS := $(CURDIR)/common/tboot.lds
 
-$(TARGET).gz : $(TARGET)
+$(TARGET).strip : $(TARGET)
+	strip $< -o $@
+
+$(TARGET).gz : $(TARGET).strip
 	gzip -n -f -9 < $< > $@
 
 $(TARGET) : $(OBJS) $(TARGET_LDS)
-	$(LD) $(LDFLAGS) -T $(TARGET_LDS) -N $(OBJS) -o $(@D)/.$(@F).0
-	$(NM) -n $(@D)/.$(@F).0 >$(TARGET)-syms
-	$(LD) $(LDFLAGS) -T $(TARGET_LDS) $(LDFLAGS_STRIP) $(@D)/.$(@F).0 -o $(TARGET)
-	rm -f $(@D)/.$(@F).0
+	$(LD) $(LDFLAGS) -T $(TARGET_LDS) -N $(OBJS) -o $@
+	$(NM) -n $@ >$(TARGET)-syms
 
 $(TARGET_LDS) : $(TARGET_LDS).x $(HDRS)
-	$(CPP) -P -E -Ui386 $(AFLAGS) -o $@ $<
+	$(CPP) -x c -P -E -Ui386 $(AFLAGS) -o $@ $<
 
 $(TARGET_LDS).x : FORCE

=== debian/changelog ===
tboot (1.9.12+hg20200718-1) unstable; urgency=medium

  * Initial release (Closes: #803180)

 -- Timo Lindfors <timo.lindfors@iki.fi>  Fri, 14 Aug 2020 22:11:59 +0300

=== debian/control ===
Source: tboot
Section: admin
Priority: optional
Maintainer: Timo Lindfors <timo.lindfors@iki.fi>
Build-Depends: debhelper (>= 11), libtspi-dev, zlib1g-dev
Standards-Version: 4.5.0
Homepage: https://sourceforge.net/projects/tboot/
Vcs-Browser: https://salsa.debian.org/debian/tboot
Vcs-Git: https://salsa.debian.org/debian/tboot.git

Package: tboot
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: module for a measured and verified launch of an OS kernel/VMM
 Trusted Boot (tboot) is an open source, pre-kernel/VMM module that uses
 Intel(R) Trusted Execution Technology (Intel(R) TXT) to perform a measured
 and verified launch of an OS kernel/VMM.

=== debian/watch ===
version=4
http://sf.net/tboot/ tboot-(.*)\.tar\.gz\.gpg debian uupdate

## tboot 1.10.2+dfsg.0

=== docs/Makefile ===
--- 
+++ 
@@ -27,10 +27,9 @@
 install :
 	[ -d $(TBOOT_MANPATH)/man8 ] || $(INSTALL_DIR) $(TBOOT_MANPATH)/man8
 	$(INSTALL_DATA) -t $(TBOOT_MANPATH)/man8 \
-	man/txt-acminfo.8 man/lcp_readpol.8 man/lcp_writepol.8 man/tb_polgen.8 \
-	man/txt-stat.8 man/lcp2_crtpol.8 man/lcp2_crtpolelt.8 man/lcp2_crtpollist.8 \
-	man/lcp2_mlehash.8 man/txt-parse_err.8 man/tpmnv_defindex.8 man/tpmnv_getcap.8 \
-	man/tpmnv_lock.8 man/tpmnv_relindex.8
+	man/txt-acminfo.8 man/tb_polgen.8 man/txt-stat.8 man/lcp2_crtpol.8 \
+	man/lcp2_crtpolelt.8 man/lcp2_crtpollist.8 man/lcp2_mlehash.8 \
+	man/txt-parse_err.8
 
 
 clean :

=== debian/changelog ===
tboot (1.10.2+dfsg.0-1ubuntu1) jammy; urgency=medium

  * debian/patches/openssl3-compat.patch: cherry-pick commit 1d7d6d196bb1
    from upstream for compatibility with OpenSSL 3.  Closes: #1006588.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 11 Mar 2022 21:18:37 +0000

tboot (1.10.2+dfsg.0-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 16:22:28 +0100

tboot (1.10.2+dfsg.0-1) unstable; urgency=medium

  * New upstream version (Closes: #984362)

 -- Timo Lindfors <timo.lindfors@iki.fi>  Sat, 03 Jul 2021 21:18:08 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: tboot
 Section: admin
 Priority: optional
-Maintainer: Timo Lindfors <timo.lindfors@iki.fi>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Timo Lindfors <timo.lindfors@iki.fi>
 Build-Depends: debhelper (>= 11), libtspi-dev, zlib1g-dev
 Standards-Version: 4.5.0
 Homepage: https://sourceforge.net/projects/tboot/

=== debian/watch ===
version=4
opts="dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,pgpmode=self,repacksuffix=+dfsg.0,repack" \
 http://sf.net/tboot/ \
 tboot-(.*)\.tar\.gz\.gpg \
 debian uupdate

## tboot 1.10.5

=== tboot/Makefile ===
--- 
+++ 
@@ -17,14 +17,16 @@
 obj-y += common/elf.o common/hash.o common/index.o common/integrity.o
 obj-y += common/linux.o common/loader.o common/memcmp.o common/memcpy.o
 obj-y += common/misc.o common/mutex.o common/paging.o common/pci_cfgreg.o
-obj-y += common/policy.o common/printk.o common/rijndael.o common/sha1.o
+obj-y += common/policy.o common/printk.o common/sha1.o
 obj-y += common/strcmp.o common/strlen.o common/strncmp.o common/strncpy.o
 obj-y += common/strtoul.o common/tb_error.o common/tboot.o common/tpm.o
-obj-y += common/vga.o common/vmac.o common/vsprintf.o common/lz.o
+obj-y += common/vga.o common/vsprintf.o common/lz.o common/memlog.o
 obj-y += txt/acmod.o txt/errors.o txt/heap.o txt/mtrrs.o txt/txt.o
 obj-y += txt/verify.o txt/vmcs.o
 obj-y += common/tpm_12.o common/tpm_20.o 
 obj-y += common/sha256.o common/sha512.o common/sha384.o common/efi_memmap.o
+obj-y += common/poly1305/poly1305.o common/poly1305/poly1305-x86.o
+obj-y += common/poly1305/x86cpuid.o
 
 OBJS := $(obj-y)
 
@@ -66,7 +68,7 @@
 
 
 clean :
-	rm -f $(TARGET)* $(TARGET_LDS) *~ include/*~ include/txt/*~ *.o common/*~ txt/*~ common/*.o txt/*.o
+	rm -f $(TARGET)* $(TARGET_LDS) *~ include/*~ include/txt/*~ *.o common/*~ txt/*~ common/*.o txt/*.o common/poly1305/*.o
 	rm -f tags TAGS cscope.files cscope.in.out cscope.out cscope.po.out
 
 
@@ -139,3 +141,6 @@
 # -std=gnu{89,99} gets confused by # as an end-of-line comment marker
 %.s : %.S $(HDRS)  $(BUILD_DEPS)
 	$(CPP) $(AFLAGS) $< -o $@
+
+%.S : %.pl $(HDRS) $(BUILD_DEPS)
+	/usr/bin/perl $< "elf" $(AFLAGS) $@

=== utils/Makefile ===
--- 
+++ 
@@ -11,9 +11,10 @@
 
 include $(ROOTDIR)/Config.mk
 
-TARGETS := txt-stat parse_err acminfo
+TARGETS := txt-stat txt-parse_err txt-acminfo
 
 CFLAGS += -D_LARGEFILE64_SOURCE
+LIBS += $(ROOTDIR)/safestringlib/libsafestring.a
 
 #
 # universal targets
@@ -54,10 +55,10 @@
 txt-stat : txt-stat.o
 	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@
 
-parse_err : parse_err.o
+txt-parse_err : txt-parse_err.o
 	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@
 
-acminfo : acminfo.o
+txt-acminfo : txt-acminfo.o
 	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) -o $@
 %.o : %.c $(BUILD_DEPS)
 	$(CC) $(CFLAGS) -DNO_TBOOT_LOGLVL -c $< -o $@

=== deprecated/lcptools/Makefile ===
# Copyright (c) 2006-2010, Intel Corporation
# All rights reserved.

# -*- mode: Makefile; -*-

#
# lcptools makefile
#

ROOTDIR ?= $(CURDIR)/../..

include $(ROOTDIR)/Config.mk


TPMNV_TARGETS := \
	tpmnv_defindex \
	tpmnv_relindex \
	tpmnv_lock     \
	tpmnv_getcap   

LCP_TARGETS := \
	lcp_writepol   \
	lcp_readpol    

tpmnv : $(TPMNV_TARGETS) $(LCP_TARGETS)


#
# universal rules
#

build : tpmnv


dist : install


install :
	@set -e; for i in $(TPMNV_TARGETS) $(LCP_TARGETS);\
	do \
		$(MAKE) DISTDIR=$(DISTDIR) INST_TARGET=$(DISTDIR)/usr/sbin/$$i do_install; \
	done

.PHONY: do_install
do_install : $(INST_TARGET)

$(INST_TARGET) : $(notdir $(INST_TARGET))
	[ -d $(DISTDIR)/usr/sbin ] || $(INSTALL_DIR) $(DISTDIR)/usr/sbin
	$(INSTALL_PROG) -t $(DISTDIR)/usr/sbin $^


clean :
	rm -f *~ *.a *.so *.o *.rpm $(DEP_FILES) $(TPMNV_TARGETS) $(LCP_TARGETS) trousers_dep


mrproper : clean


distclean : clean

#
# trousers
#

trousers_dep:
	@printf "#include <trousers/tss.h>\n" | $(CC) -x c $(CFLAGS) $(LDFLAGS) $(LIBS) - -Wl,--defsym=main=0 -o $@ >/dev/null 2>&1 || (echo trousers-devel package is not installed && false)

#
# dependencies
#

LDFLAGS += -L.


# LCP v1 and tpmnv_*

UTIL_OBJS := lcptools.o lcputils.o

LIBS += -lcrypto -ltspi -lz

$(TPMNV_TARGETS) : tpmnv_% : %.o $(UTIL_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) $(ROOTDIR)/safestringlib/libsafestring.a -o $@

$(LCP_TARGETS) : lcp_% : %.o $(UTIL_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LIBS) $(ROOTDIR)/safestringlib/libsafestring.a -o $@


#
# implicit rules
#

HDRS := $(wildcard $(ROOTDIR)/include/*.h) $(wildcard $(CURDIR)/*.h)

BUILD_DEPS := $(ROOTDIR)/Config.mk $(CURDIR)/Makefile

%.o : %.c $(HDRS) $(BUILD_DEPS) trousers_dep
	$(CC) $(CFLAGS) -DNO_TBOOT_LOGLVL -c $< -o $@

=== debian/changelog ===
tboot (1.10.5-4) unstable; urgency=medium

  * Rename /etc/default/tboot as /etc/default/grub-tboot.
  * Add autopkgtest for /boot/*SINIT* handling.

 -- Timo Lindfors <timo.lindfors@iki.fi>  Wed, 29 Jun 2022 16:08:00 +0300

tboot (1.10.5-3) unstable; urgency=medium

  * Source-only upload.
  * Add autopkgtest for lcp2_mlehash.

 -- Timo Lindfors <timo.lindfors@iki.fi>  Wed, 22 Jun 2022 11:29:13 +0300

tboot (1.10.5-2) unstable; urgency=medium

  * Backport upstream patches:
    - upstream_changeset_658.patch
    - upstream_changeset_662.patch
    - upstream_changeset_661.patch
    - upstream_changeset_660.patch
    - upstream_changeset_659.patch
  * Include proposed patches:
    - proposed_patch_cppflags.patch
    - proposed_patch_time.patch
  * Ship /etc/default/tboot that tries to workaround the situation
    where grub loads an SINIT ACM module to an address that overlaps
    with tboot's data structures that are in hardcoded addresses.
  * Drop support for i386.
  * Add autopkgtest tests.

 -- Timo Lindfors <timo.lindfors@iki.fi>  Tue, 21 Jun 2022 19:03:20 +0300

tboot (1.10.5-1) unstable; urgency=medium

  * New upstream version (Closes: #1006588)

 -- Timo Lindfors <timo.lindfors@iki.fi>  Wed, 09 Mar 2022 16:35:55 +0200

=== debian/control ===
Source: tboot
Section: admin
Priority: optional
Maintainer: Timo Lindfors <timo.lindfors@iki.fi>
Build-Depends: debhelper (>= 11), debhelper-compat (= 13), libtspi-dev, zlib1g-dev
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://sourceforge.net/projects/tboot/
Vcs-Browser: https://salsa.debian.org/debian/tboot
Vcs-Git: https://salsa.debian.org/debian/tboot.git

Package: tboot
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: module for a measured and verified launch of an OS kernel/VMM
 Trusted Boot (tboot) is an open source, pre-kernel/VMM module that uses
 Intel(R) Trusted Execution Technology (Intel(R) TXT) to perform a measured
 and verified launch of an OS kernel/VMM.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

=== debian/tests/control ===
Test-Command: [ $(/usr/sbin/lcp2_mlehash --create --cmdline foo --alg sha1 /boot/tboot.gz | wc --words) -eq 20 ]
Features: test-name=mlehash-sha1
Restrictions: superficial

Test-Command: [ $(/usr/sbin/lcp2_mlehash --create --cmdline foo --alg sha256 /boot/tboot.gz | wc --words) -eq 32 ]
Features: test-name=mlehash-sha256
Restrictions: superficial

Tests: sinit-in-grub-configuration
Depends: @, grub-efi-amd64 | grub-pc, linux-image-amd64
Restrictions: needs-root, isolation-machine, superficial, skippable, flaky

Test-Command: debian/tests/reboot --on-unsupported-hardware
Restrictions: breaks-testbed, needs-root, isolation-machine, needs-reboot
Features: test-name=reboot-with-unsupported-hardware

Test-Command: debian/tests/reboot --tpm 1 --boot bios
Depends: @, tpm-tools
Restrictions: breaks-testbed, needs-root, isolation-machine, needs-reboot, skippable, flaky
Features: test-name=reboot-with-tpm1-bios

Test-Command: debian/tests/reboot --tpm 2 --boot efi
Depends: @, tpm2-tools
Restrictions: breaks-testbed, needs-root, isolation-machine, needs-reboot, skippable, flaky
Features: test-name=reboot-with-tpm2-efi

Test-Command: /bin/true
Depends: grub-efi-amd64 [amd64], grub-pc [amd64], linux-image-amd64 [amd64]
Restrictions: hint-testsuite-triggers
